﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Biblioteque_de_Class
{
    public class Note
    {
        private string Nom
        {
            get { return Nom; }
            set { if (value == null) { Nom = "Note sans nom"; } else { Nom = value; } }
        }

        ///private string Text { get; set; } Attribut pour le texte de la note
        private string LogoPATH
        {
            get { return LogoPATH; }
            set { if (value == null) { LogoPATH = "PATH TO DEFAULT LOGO"; } else { LogoPATH = value; } }
        }
        private DateOnly DateCreation { get;}
        private DateOnly DateModif { get; set; }
        private List<NoteImage> listeImage;
        private List<String> listeLigneTexte;
        private List<Utilisateur> cooperateurs;
        private List<Utilisateur> editeurs;
        private Utilisateur owner;

        public Note(string nom, string logoPATH, Utilisateur uOwner)
        {
            Nom = nom;
            LogoPATH = logoPATH;
            DateCreation = DateOnly.FromDateTime(DateTime.Now);
            DateModif = DateOnly.FromDateTime(DateTime.Now);
            listeImage = new List<NoteImage>();
            listeLigneTexte = new List<String>();
            cooperateurs = new List<Utilisateur>();
            editeurs = new List<Utilisateur>();

            owner = uOwner;
        }

        public string GetNom() { return Nom; }
        public string GetLogoPATH() { return LogoPATH; }
        public DateOnly GetDateCreation() { return DateCreation; }
        public DateOnly GetDateModif() { return DateModif; }
        public List<NoteImage> GetListeImage() { return listeImage; }
        public List<string> GetListeLigneTexte() { return listeLigneTexte; }
        public List<Utilisateur> GetCooperateurs() { return cooperateurs; }
        public List<Utilisateur> GetEditeurs() { return editeurs; }
        public Utilisateur GetOwner() { return owner; }

        public override string ToString() => $"note -> nom : {Nom}\nlogoPATH : {LogoPATH}\nhow many line : {listeLigneTexte.Count()}";

        public void ModifNom(string nom) { Nom = nom; }
        public void ModifLogoPATH(string logoPATH) { LogoPATH = logoPATH; }
        public void ModifDateModif() { DateModif = DateOnly.FromDateTime(DateTime.Now); }

        /// <summary>
        /// vérifier si l'utilisateur est le propriétaire de la note
        /// </summary>
        public bool VerifOwner(Utilisateur user) 
        { 
            if (user == owner) { return true; }
            else { return false; }
        }

        public void AjouterImage(string linkImage, string position)
        {
            foreach (NoteImage image in this.GetListeImage())
            {
                if (image.GetLinkImage() == linkImage)
                {
                    
                }
            }
        }

        public void SuppImage(string image)
        {
            /// il faut une nouvelle structure pour pouvoir stocker les images
        }

        /// <summary>
        /// vérifier si l'utilisateur est un éditeur de la note
        /// </summary>
        public bool VerifPriviledge(Utilisateur user)
        {
            if (editeurs.Contains(user))
            {
                return true;
            }
            else
            {
                throw new Exception("user is not editeur");
            }
        }

        /// <summary>
        /// ajouter un utilisateur en tant que coopérateur
        /// </summary>
        public void AjouterCoop(Utilisateur owner, Utilisateur user) 
        {
            if (VerifOwner(owner)) { cooperateurs.Add(user); }
            else { throw new Exception("user is not owner"); }
        }

        /// <summary>
        /// supprimer un utilisateur en tant que coopérateur
        /// </summary>
        public void SupCoop(Utilisateur owner, Utilisateur user)
        {
            if (VerifOwner(owner)) { cooperateurs.Remove(user); }
            else { throw new Exception("user is not owner"); }
        }

        /// <summary>
        /// passer un coopérateur en tant qu'éditeur
        /// </summary>
        public void AjouterEdit(Utilisateur owner, Utilisateur user) 
        {
            if (VerifOwner(owner)) { editeurs.Add(user); }
            else { throw new Exception("user is not owner"); }
        }

        /// <summary>
        /// supprimer un coopérateur de la liste des éditeurs
        /// </summary>
        public void SupEdit(Utilisateur owner, Utilisateur user) 
        {
            if (VerifOwner(owner)) { editeurs.Remove(user); }
            else { throw new Exception("user is not owner"); }
        }
    }
}
